<template>
  <div id="activity">
    <transition name="fade">      
      <ActivityCreateModal v-if="showModal" @close="closeModal" @create="updateList"/>
    </transition>
    <h1>Hoạt động</h1>
    <button class="create-btn" @click="openModal">Tạo hoạt động</button>
      <div class="current-active">
        <div class="group">
          <label>Đang diễn ra ({{ activityOpenList.length}})</label>
          <button class="drop-btn" @click="showCurrentGroup">{{showCurrent?"Ẩn":"Hiện"}}</button>
        </div>        
        <div v-if="showCurrent && activityOpenList.length > 0 " class="activities">
            <div v-for="item in activityOpenList" :key="item">
            <ActivityCard :activity="item" @end="updateList"/>
            <!-- <playlist-item :list="item"/> -->
            </div>
        </div>
      </div>
      <div class="current-active">
        <div class="group">
          <label>Đã kết thúc ({{ activityCloseList.length}})</label>
          <button class="drop-btn" @click="showOldGroup">{{showOld?"Ẩn":"Hiện"}}</button>
        </div>        
        <div v-if="showOld && activityCloseList.length > 0 " class="activities">
            <div v-for="item in activityCloseList" :key="item">
            <ActivityCard :activity="item"/>
            <!-- <playlist-item :list="item"/> -->
            </div>
        </div>
      </div>
  </div>
</template>
  
<script>
import ActivityCard from '@/components/ActivityCard.vue'
import ActivityCreateModal from '@/components/ActivityCreateModal.vue';
import DonationService from '@/services/DonationService';

export default {
  name: 'Activity-page',
  components: {
    ActivityCard,
    ActivityCreateModal
  },
  data(){
    return {
      showModal: false,
      showCurrent: true,
      showOld: false,
      activityOpenList: [
        {
          name: "Donation 1"
        },
        {
          name: "Donation 2"
        }
      ],
      activityCloseList: []
    }
  },
  methods: {
    openModal(){
      this.showModal = true
    },
    closeModal(){
      this.showModal = false
    },
    showCurrentGroup(){
      this.showCurrent = !this.showCurrent;
    },
    showOldGroup(){
      this.showOld = !this.showOld;
    },
    async getOpenDonations(){
      try{
        let response = await DonationService.getDonations()
        console.log(response)
        if(response.status == 200){
          this.activityOpenList = response.data.filter(donate => donate.enable == true)
        }
        else{          
          alert(response.statusText)
        }        
        console.log('getOpenDonations')
      }
      catch(err){        
        console.log(err)
        alert('Something when wrong')
      }
    },
    async getCloseDonations(){
      try{
        let response = await DonationService.getDonations()
        console.log(response)
        if(response.status == 200){
          this.activityCloseList = response.data.filter(donate => donate.enable == false)
        }
        else{          
          alert(response.statusText)
        }        
        console.log('getCloseDonations')
      }
      catch(err){        
        console.log(err)
        alert('Something when wrong')
      }
    },
    updateList(){
      this.getOpenDonations()
      this.getCloseDonations()
      this.showModal = false
    }
  },
  mounted(){
    if(this.$store.getters.isAuthenticated){
      this.updateList()
    }
  }
}
</script>

<style scoped>
#activity {
  position:absolute;
  top: 0px;
  left: 0px;
  right: 0px;
  bottom: 0px;
  padding: 0px 20px 40px 20px;
}

.create-btn{
  margin-bottom: 20px;
  border-radius: 5px;
  padding: 10px;
  border: 1px solid blue;
  background-color: #22f;  
  color: white;
}

.create-btn:hover{
  cursor: pointer;
}

.fade-enter-from, .fade-leave-to {
  opacity: 0;
}

.fade-enter-active, .fade-leave-active {
  transition: opacity 0.2s ease;
}

.current-active {
  display: flex;
  flex-direction: column;
}

.group {
  display: flex;
  justify-content: space-between;
  padding: 10px;
  border-radius: 10px;
}

.group:hover{  
  background-color: #ddd;
}

.group > button:hover {
  cursor: pointer;
}
.group > label {
  font-size: 1em;
  font-weight: bold;
  width: 100%;
}

.drop-btn{
  width: fit-content;
  border: 0;
  padding: 0;
  background: transparent;
  color: blue
}

.activities{
  display: flex;
  flex-wrap: wrap;
}
</style>
  